<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"format.lib.php", "categories", "users", "pages"
	);

	Extract (
		URLGetArgs ("null/null/action=alpha?id=int&page=page")
	);

	switch ($action) {
		case "edit":
			if ($id) {

				$tpl = new ContentBlock();

				$tpl->insert("BLOCK_CONTENT", "pages/admin.edit.tpl");

				$q = $db->query("
					SELECT
						id, category_id, title, content, author_id, editor_id, date_created, date_modified, show_title, status
					FROM ".db_table("page")." WHERE id = '{$id}'
				", __FILE__, __LINE__);

				if ($db->numRows($q)) {

					$row = $db->fetchRow($q);

					saneHTML($row, "content");

					format::htmlFilter($row["content"], $row["author_id"]);

					$actions = new tplButtonBox();
					$actions->add (
						mklink("index.php/module=admin/base=pages", _l("L_PAGES"), "pages.png"),
						mklink("index.php/module=admin/base=pages/action=edit?id={$row["id"]}", _l("L_EDIT"), "edit.png"),
						mklink("modules/pages/main.act.php?id={$row["id"]}&action=delete&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true)
					);
					$actions = $actions->make();

					$tpl->setArray (
						Array (
							"BLOCK_TITLE"		=> _l("L_PAGES"),
							"BLOCK_ICON"		=> mkIcon("pages.png", 16),
							"BLOCK_SUBTITLE"	=> _l("L_EDIT"),
							"ACTION"			=> "edit",
							"ACTIONS"			=> $actions,
							"RETURN"			=> "index.php/module=admin/base=pages"
						)
					);

					$tpl->setArray($row);

					$mcBuff = $tpl->make();
				}
			}
		break;
		case "create":
			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "pages/admin.$action.tpl");

			$actions = new tplButtonBox();
			$actions->add (
				mklink("index.php/module=admin/base=pages", _l("L_PAGES"), "pages.png")
			);
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_PAGES"),
					"BLOCK_ICON"		=> mkIcon("pages.png", 16),
					"STATUS"			=> 1,
					"CATEGORY_ID"		=> 0,
					"ACTION"			=> $action,
					"TITLE"				=> "",
					"CONTENT"			=> "",
					"ACTIONS"			=> $actions,
					"ID"				=> 0,
					"RETURN"			=> "index.php/module=admin/base=pages",
					"SHOW_TITLE"			=> 1
				)
			);

			$mcBuff = $tpl->make();
		break;
		default:

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "pages/admin.default.tpl");

			$pager = $db->pager (
				"SELECT id FROM ".db_table("page")."",
				"index.php/module=admin/base=pages?page=%p", $page,
				conf::getkey("pages", "items_per_admin_page", 16, 'i')
			);

			$q = $db->query ("
				SELECT
					id, category_id, title, content, editor_id, date_modified, status
				FROM ".db_table("page")."
				ORDER BY status ASC, title ASC ".$pager["sql"]."
			", __FILE__, __LINE__);

			$pages = $db->numRows($q);

			while ($row = $db->fetchRow($q)) {

				saneHTML($row, "content");

				$row["ACTIONS"] = new tplButtonBox();
				$row["ACTIONS"]->add(mklink("index.php/module=pages/title=".urlTitleEncode($row["title"])."?id={$row["id"]}", _l("L_VIEW"), "view.png"));

				$row["ACTIONS"]->add(
					mklink("index.php/module=admin/base=pages/action=edit?id={$row["id"]}", _l("L_EDIT"), "edit.png"),
					mklink("modules/pages/main.act.php?action=delete&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true)
				);

				if (!$row["status"])
					$row["ACTIONS"]->add(mklink("modules/pages/main.act.php?action=publish&id={$row["id"]}&auth={C_AUTH_STR}", _l("L_PUBLISH"), "ok.png"));
				$row["ACTIONS"] = $row["ACTIONS"]->make();

				$tpl->setArray($row, "PAGE");
				$tpl->saveBlock("PAGE");
			}

			$actions = new tplButtonBox();
			$actions->add (
				mklink("index.php/module=admin/base=pages/action=create", _l("L_COMPOSE"), "new.png")
			);
			$actions = $actions->make();

			$tpl->setArray (
				Array (
					"BLOCK_TITLE"		=> _l("L_PAGES"),
					"BLOCK_ICON"		=> mkIcon("pages.png", 16),
					"PAGER"				=> $pager["html"],
					"ACTIONS"			=> $actions
				)
			);

			$mcBuff = $tpl->make();

		break;
	}
?>