<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"categories"
	);

	Extract (
		URLGetArgs("null/title=data?action=alpha&id=int")
	);

	switch ($action) {
		case "category":
			if ($id && categories::auth($id)) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "pages/main.category.tpl");

				$q = $db->query ("
				SELECT
					id, title, content
				FROM ".db_table("page")."
				WHERE category_id = '{$id}'
				AND status = '1' ORDER BY title
				", __FILE__, __LINE__);

				if ($db->numRows($q)) {
					while ($row = $db->fetchRow($q)) {
						$tpl->setArray($row, "PAGE");
						$tpl->saveBlock("PAGE");
					}
				}
				$tpl->setArray (
					Array (
						"BLOCK_TITLE"	=> htmlspecialchars($title),
						"BLOCK_ICON"	=> mkicon("pages.png")
					)
				);
				$mcBuff = $tpl->make();
			}
		break;
		default:

			if (!$title)
				$title = conf::getKey("pages", "default", "Index", 's');

			$cat_lock = categories::db_categorylock("category_id");

			$q = $db->query ("
			SELECT
				id, category_id, title, content, show_title, author_id
			FROM ".db_table("page")."
			WHERE (id = '{$id}' OR title='{$title}')
			AND status = '1' AND ($cat_lock)
			", __FILE__, __LINE__);

			if ($db->numRows($q)) {

				$row = $db->fetchRow($q);

				saneHTML($row, "content");

				format::style($row["content"], $row["author_id"]);

				$row["category_id"] = categories::getCategory($row["category_id"]);

				$tpl = new ContentBlock("ContentBlock", "pages/_page.inc.tpl");
				$tpl->setArray($row);

				pageSetTitle($row["title"]);

				$mcBuff = $tpl->make();

			} else {

				// search page by title
				$keywords = preg_replace("/[^a-zA-Z0-9]/", " ", $title);
				$keywords = "%".preg_replace("/\s+/", "%", $keywords)."%";

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "pages/main.not_found.tpl");

				$q = $db->query ("
				SELECT
					id, category_id, title, content
				FROM ".db_table("page")."
				WHERE title LIKE '{$keywords}'
				AND status = '1' AND ($cat_lock)
				", __FILE__, __LINE__);

				if ($db->numRows($q)) {
					while ($row = $db->fetchRow($q)) {
						$tpl->setArray($row, "RESULT");
						$tpl->saveBlock("RESULT");
					}
				}
				$tpl->setArray (
					Array (
						"BLOCK_TITLE"	=> _l("L_NOT_FOUND"),
						"BLOCK_ICON"	=> mkicon("pages.png")
					)
				);
				$mcBuff = $tpl->make();
			}
		break;
	}

?>