<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class gekkoModule_Pages {
		function create_menu() {
			// don't need a menu entry
			return true;
		}
		function configure() {

		}
		function install() {
			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("page")." (
				id MEDIUMINT (8) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				category_id SMALLINT (5) UNSIGNED NOT NULL,
				title VARCHAR (128),
				content TEXT,
				author_id MEDIUMINT (8) UNSIGNED NOT NULL,
				editor_id MEDIUMINT (8) UNSIGNED NOT NULL,
				date_created DATETIME NOT NULL default '0000-00-00 00:00:00',
				date_modified TIMESTAMP(19),
				status ENUM('0','1') NOT NULL default '1',
				show_title ENUM('0','1') NOT NULL default '1'
			)
			",__FILE__, __LINE__, true);

			# default values
			$GLOBALS["db"]->query("
				INSERT INTO ".db_table("page")." (
					category_id,
					title,
					content,
					author_id,
					date_created,
					status
				) VALUES (
					1,
					'Index',
					'Thanks for using Gekko!',
					'1',
					CURRENT_TIMESTAMP(),
					1
				)
			", __FILE__, __LINE__, true);

			gekkoModule::register($GLOBALS["cgdb"]["pages"], "pages", "*", $GLOBALS["cgdb"]["pages"]);
		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("page"),__FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			$db =& $GLOBALS["db"];
			if (Packages::checkVersion("0.5.7", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("page")."
				CHANGE COLUMN Status Status ENUM('0','1') NOT NULL default '1',
				CHANGE COLUMN showTitle showTitle ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}
			if (Packages::checkVersion("0.5.9", $provided_v) < 0) {
				$db->query("ALTER TABLE ".db_table("page")."
				DROP textid",
				__FILE__, __LINE__);
			}
			if (packages::checkVersion("0.6.4", $provided_v) < 0) {

				$db->query("
					ALTER TABLE ".db_table("page")."
					CHANGE COLUMN category category_id SMALLINT (5) UNSIGNED NOT NULL,
					CHANGE COLUMN authorid author_id MEDIUMINT (8) UNSIGNED NOT NULL,
					CHANGE COLUMN lasteditor editor_id MEDIUMINT (8) UNSIGNED NOT NULL,
					CHANGE COLUMN showtitle show_title ENUM('0','1') NOT NULL default '1',
					ADD COLUMN date_created DATETIME NOT NULL,
					ADD COLUMN date_modified TIMESTAMP(19)
				", __FILE__, __LINE__);

				$db->query("UPDATE ".db_table("page")." SET
				date_created = FROM_UNIXTIME(created),
				date_modified = FROM_UNIXTIME(modified)",
				__FILE__, __LINE__);

				$db->query("ALTER TABLE ".db_table("page")."
				DROP COLUMN created,
				DROP COLUMN modified", __FILE__, __LINE__);
			}
		}
		function ext_uninstall($module) {

		}
	}
?>